$("#map").bind("startApp",function(e){
	ML_loadLayers(); // Carga las capas de ARBA
});

$("#map").bind("setCapaBaseArba",function(e){
	ML_remove_and_add(); 
});

$("#map").bind("openInfoSDDHH",function(e){
	ML_markersInfo.clearMarkers(); 
});


$("#map").bind("clearInfo",function(e){
	ML_ClearInfoLayerFeature();
});


$("#map").bind("closeInfo",function(e){
	ML_markersInfo.clearMarkers();
	ML_ClearInfoLayerFeature();
});



$("#map").bind("changeVisibilityLayer",function(e,lay){
	
	if((lay.layeride || lay.service == "WFS") && lay.getVisibility())
	{
		//remover y luego agregar las capas de marcas
		
		map.removeLayer(ML_markersInfo);
		
		if(ML_markersPlace!=undefined)
			map.removeLayer(ML_markersPlace);
		
		map.addLayer(ML_markersInfo);
		
		if(ML_markersPlace!=undefined)
			map.addLayer(ML_markersPlace);
		
		map.removeLayer(ML_layerLabel);
		
		if(ML_layerLabel!=undefined)
			map.addLayer(ML_layerLabel);
	}
});



$("#map").bind("completeMap",function(e){
	$('.accordion-group').on('show.bs.collapse', function () {
	    
		var a = $(this);
		
		setTimeout(function(){ 
			
			a.find(".accordion-toggle").each(function( index ) {
		    	if($( this )[0].scrollWidth - 200 > 0)
		    		
					$( this ).mouseover(function() {
						$( this ).css("margin-left",(200 - $( this )[0].scrollWidth)+"px");
					});
		    	
					$( this ).mouseout(function() {
						$( this ).css("margin-left","0px");
					});


		    });
			
		}, 250);
		
	    
	    
	});
});






function ML_remove_and_add()
{
	
	$.each(map.layers, function(index, layer) {
		//saca el layer del mapa y lo vuelve a agregar
		if(layer.service=='WMS' && layer.getVisibility() && layer != ML_ArbaCapaBase)
		{
			map.removeLayer(layer);
			map.addLayer(layer);
			
		}
	});
}

//Layer de markers utilizados en el Info
var ML_markersInfo;
var ML_markersPlace;

// Busca los layers disponibles para el usuario logueado
function ML_loadLayers()
{
	
	$.getJSON("client/loadLayer",function(provider) {
		$.each(provider.layers, function(index, value) {
			
			ML_addLayer(value);
			
		});
		
		
		//Agrego una capa donde se muestran las consultas
		ML_addQueryLayerFeature();
		
		
		//Agrego una capa para contornear el poligono de la parcela/macizo donde se pidio info
		ML_addInfoLayerFeature();
		
		
		//Agrego una capa donde se muestran los lugares a donde se pidio info 
		ML_addInfoLayer();
		
		
		if(provider.extent!=undefined)
		{
			/*Si la url trae el extent entonces eliminarla en este caso*/
			
			if(window.location.search.substr(1).indexOf("extent=")!=-1)
				window.history.pushState({urlPath:'/cartoArba'},"",'/cartoArba/')
			
			var arr = provider.extent.split(",");
			var extent_partido = new OpenLayers.Bounds(arr[0],arr[1],arr[2],arr[3]);
			map.zoomToExtent(extent_partido);
		}
		else
				
			{
				if(window.location.search.substr(1).indexOf("extent=")==-1)
					map.zoomToExtent(extent);
			}
			
		menulayer_createMenu(); //Llama a crear el menu de los layers menuLayer.jsp
		ML_createLayerLabel(); // Crea el layer de labels
		
		
		$("#map").trigger("completeMap");
    }); 
	
	
}


/**
 * Agrega una capa para poner los features de las consultas 
 */
var vectorQueryLayer;
function ML_addQueryLayerFeature()
{
	vectorQueryLayer = new OpenLayers.Layer.Vector("Consultas", {
	    styleMap: new OpenLayers.StyleMap({'default':{
	    	stroke: true,
            fill: true,
	        strokeColor: "${strokeColor}",
	        strokeOpacity: "${strokeOpacity}",
	        strokeWidth: "${strokeWidth}",
	        fillColor:"${fillColor}",
	        fillOpacity: "${fillOpacity}",
	        pointRadius: "${pointRadius}",
	        pointerEvents: "${pointerEvents}",
	        label : "${valor}",
            fontColor: "${fontColor}",
            fontSize: "${fontSize}",
            fontFamily: "${fontFamily}",
            fontWeight: "${fontWeight}",
            labelAlign: "${labelAlign}",
            labelXOffset: "${xOffset}",
            labelYOffset: "${yOffset}",
            labelOutlineColor: "${labelOutlineColor}",
            labelOutlineWidth: "${labelOutlineWidth}",
            rotation: "${angle}",
            externalGraphic: "${externalGraphic}",
            graphicWidth: "${graphicWidth}",
            graphicHeight: "${graphicHeight}"
	    }})
	});
	vectorQueryLayer.title="Consultas";
	vectorQueryLayer.description="Capa que representa las consultas realizadas";
	vectorQueryLayer.id='-1';
	vectorQueryLayer.queryable=true;
	vectorQueryLayer.showInPanel=true;
	vectorQueryLayer.layeride=false;
	vectorQueryLayer.category="Resultados";

	map.addLayer(vectorQueryLayer);
}


/**
 * Agrega una capa para poner los features de los poligonos sobre los que se pidio info 
 */
var vectorInfoLayer;
function ML_addInfoLayerFeature()
{
	vectorInfoLayer = new OpenLayers.Layer.Vector("Consultas", {
	    styleMap: new OpenLayers.StyleMap({'default':{
	    	strokeDashstyle: "longdash",
	        strokeColor: "#FF0000",
	        strokeOpacity: 0.7,
	        strokeWidth: 1,
	        fillOpacity: 0.05,
	        fillColor: "#FF4040",
	        pointRadius: 6,
	        pointerEvents: "visiblePainted"
	    }})
	});
	vectorInfoLayer.title="Informacion";
	vectorInfoLayer.description="Capa que representa los poligonos sobre los que se pidio informacion";
	vectorInfoLayer.id='-2';
	vectorInfoLayer.queryable=false;
	vectorInfoLayer.showInPanel=false;
	vectorInfoLayer.layeride=false;
	vectorInfoLayer.category="Informacion";

	map.addLayer(vectorInfoLayer);
}


/**Agrega la capa de markers para Info
 * 
 */
function ML_addInfoLayer()
{
	ML_markersInfo = new OpenLayers.Layer.Markers( "Markers" );
	ML_markersInfo.showInPanel=false; // Determina si el layer es mostrado en la capa de layers
    map.addLayer(ML_markersInfo);
    ML_markersInfo.setZIndex(1501);
}

/**Agrega la capa de markers para Mis Lugares
 * 
 */
function ML_addPlaceLayer()
{
	ML_markersPlace = new OpenLayers.Layer.Markers( "Markers Places" );
	ML_markersPlace.showInPanel=false; // Determina si el layer es mostrado en la capa de layers
    map.addLayer(ML_markersPlace);
    ML_markersPlace.setZIndex(1501);
}


/**
 * Borra la marca anterior y agrega una nueva marca en el punto pasado por parametro (usado para info)
 * @param lonlat
 */
function ML_showMarkerInfo(lonlat)
{
	ML_markersInfo.clearMarkers();
	
	var size = new OpenLayers.Size(24,24);
    var offset = new OpenLayers.Pixel(-(size.w/2), -size.h);
    var icon = new OpenLayers.Icon('./resources/img/infomarker.png',size,offset);
    ML_markersInfo.addMarker(new OpenLayers.Marker(lonlat,icon));
}

function ML_deleteplacebypopup(idplace)
{
	MP_DeletePlace(idplace);	
	destroyPopups();
}



function ML_showMarkerPlace(lonlat,epsg,texto,idplace)
{
	//ML_markersPlace.clearMarkers();
	
	
	lonlat.transform(new OpenLayers.Projection(epsg),map.projection);
	
	var size = new OpenLayers.Size(24,24);
    var offset = new OpenLayers.Pixel(-(size.w/2), -size.h);
    var icon = new OpenLayers.Icon('./resources/img/mislugares.png',size,offset);
    var newMarkerPlace = new OpenLayers.Marker(lonlat,icon);
    
    newMarkerPlace.events.register('mousedown', newMarkerPlace, function(evt) {
    	
    	
    	//eliminar popups anteriores
    	destroyPopups();
    	
    	var popup = new OpenLayers.Popup.FramedCloud(
    			"chicken",
    	        lonlat,
    	        new OpenLayers.Size(100,50),
    	        '<div style="text-align:center; width:250px; height:100px; padding-left:10px;"><span style="font-size:0.8em; text-align:left;"></span><textarea style="width:100%; height:75px; margin:0px;">'+texto+'</textarea><a onclick="ML_deleteplacebypopup('+idplace+')" style="cursor:pointer;color:rgb(169, 169, 169);"><i class="fa fa-trash-o" aria-hidden="true"></i>&nbsp;Borrar ubicaci&oacute;n</a></div>',
    	        null, true);

    	map.addPopup(popup, false);
    	
    	OpenLayers.Event.stop(evt); });
    
    ML_markersPlace.addMarker(newMarkerPlace);
    

    
    /*$(newMarkerPlace.icon.imageDiv).attr("data-toggle","tooltip");
    $(newMarkerPlace.icon.imageDiv).attr("data-placement","top");
    $(newMarkerPlace.icon.imageDiv).attr("title","");
    $(newMarkerPlace.icon.imageDiv).attr("data-original-title","Tooltip on top");
    $(newMarkerPlace.icon.imageDiv).tootlip();*/
}





/**Elimina todos los features de busquedas realizadas anteriormente
 * 
 */
function ML_removeAllFinds()
{
	vectorQueryLayer.removeAllFeatures();
}

/**
 * agrega un feature a partir del wkt pasado por parametro y realiza zoom extent al wkt pasado por parametro
 * @param wkt del feature a agregar
 * @param epsg proyeccion del wkt pasado por parametro
 */
function ML_addAndZoomToWKT(wkt, epsg)
{
	
	var fwkt = new OpenLayers.Format.WKT();
	 var features = fwkt.read(wkt);
	 features.geometry.transform(epsg,'EPSG:900913');
	 var bounds;
     if(features) {
    	  if(features.constructor != Array) {
              features = [features];
          }
    	  features = MD_applyDisplacementToFeatures(features);

          var params = new Object();
          
          params.strokeColor = "#00FF00";
          params.fillOpacity = 0;
          params.fontColor = "red";
          params.labelOutlineColor = "white";
    	  
    	  for(var i=0; i<features.length; ++i) {
              if (!bounds) {
                  bounds = features[i].geometry.getBounds();
              } else {
                  bounds.extend(features[i].geometry.getBounds());
              }
              
              setStyleFeature(features[i],params);
          }
          
    	  //vectorQueryLayer.removeAllFeatures();
          vectorQueryLayer.addFeatures(features);
          bounds = new OpenLayers.Bounds(bounds.left - 50,bounds.bottom - 50,bounds.right + 50, bounds.top + 50);
          map.zoomToExtent(bounds);
      }
      else
    	  bootbox.alert("Ocurrio un error");
}


function ML_addWKTWithLabel(wkt, epsg, label)
{

	 var fwkt = new OpenLayers.Format.WKT();


	 
	 var features = fwkt.read(wkt);
	 features.geometry.transform(epsg,'EPSG:900913'); 
	 var bounds;
     if(features) {
    	  if(features.constructor != Array) {
              features = [features];
          }
    	  features = MD_applyDisplacementToFeatures(features);
    	  
          var params = new Object();
          
          params.valor = "Total "+label;
          params.strokeColor = "#0000FF";
          params.fontColor = "red";
          params.xOffset = 30;
		  params.yOffset = 30;
		  params.labelOutlineColor = "white";
		  params.fillOpacity = 0;
    	  
          for(var i=0; i<features.length; ++i) {
              if (!bounds) {
                  bounds = features[i].geometry.getBounds();
              } else {
                  bounds.extend(features[i].geometry.getBounds());
              }
              
			  setStyleFeature(features[i],params); 
          }
    	  //vectorQueryLayer.removeAllFeatures();
          vectorQueryLayer.addFeatures(features);
          /*bounds = new OpenLayers.Bounds(bounds.left - 50,bounds.bottom - 50,bounds.right + 50, bounds.top + 50);
          map.zoomToExtent(bounds);*/
      }
      else
    	  bootbox.alert("Ocurrio un error");
}



function ML_addWKTWithLabelError(wkt, epsg, label)
{

	 var fwkt = new OpenLayers.Format.WKT();


	 
	 var features = fwkt.read(wkt);
	 features.geometry.transform(epsg,'EPSG:900913'); 
	 var bounds;
     if(features) {
    	  if(features.constructor != Array) {
              features = [features];
          }
    	  features = MD_applyDisplacementToFeatures(features);
    	  
          var params = new Object();
          
          params.strokeColor = "#FF0000";
          params.fillOpacity = 0;
          params.fontColor = "red";
          params.labelOutlineColor = "white";
    	  
          for(var i=0; i<features.length; ++i) {
              if (!bounds) {
                  bounds = features[i].geometry.getBounds();
              } else {
                  bounds.extend(features[i].geometry.getBounds());
              }
              
              setStyleFeature(features[i],params); 
          }
          
    	  //vectorQueryLayer.removeAllFeatures();
          vectorQueryLayer.addFeatures(features);
          /*bounds = new OpenLayers.Bounds(bounds.left - 50,bounds.bottom - 50,bounds.right + 50, bounds.top + 50);
          map.zoomToExtent(bounds);*/
      }
      else
    	  bootbox.alert("Ocurrio un error");
}






function ML_addWKTforInfo(wkt, epsg)
{

	
	 var fwkt = new OpenLayers.Format.WKT();
	 var features = fwkt.read(wkt);
	 features.geometry.transform(epsg,'EPSG:900913');

     if(features) {
    	  if(features.constructor != Array) {
              features = [features];
          }
    	  features = MD_applyDisplacementToFeatures(features);

    	  vectorInfoLayer.removeAllFeatures();
    	  
          vectorInfoLayer.addFeatures(features);
      }
      
}

function ML_ClearInfoLayerFeature()
{
	vectorInfoLayer.removeAllFeatures();
	
}

// Redibujo los features del query
function ML_redrawAllFeatureQuery(deltax, deltay)
{
	var features = vectorQueryLayer.features;
	features = MD_applyDeltaDisplacmenteToFeatures(features,deltax, deltay);
	vectorQueryLayer.removeAllFeatures();
    vectorQueryLayer.addFeatures(features);
}


function ML_redrawAllWMS()
{
	for(var i=0;i<map.layers.length;i++)
		if(map.layers[i].service!= undefined && map.layers[i].service == "WMS" && map.layers[i].visibility)
			
			map.layers[i].redraw();
		

}




////---------------------
//Crea y agrega el layer pasado por parametro
//Dependiendo del tipo del servicio que trae por parametro. hasta el momento solo se permite WMS y GOOGLE SATELITAL
function ML_addLayer(layerdata){
	var layer = null;
	
	var strurl = layerdata.url;
	

	if(layerdata.service == "WMS")
	{
		
		if(layerdata.local)
			strurl = $(location).attr('protocol') + '//' + $(location).attr('host') + layerdata.url;
		
		layer = new OpenLayers.Layer.WMSCustom(layerdata.title,
				[strurl,'http://localhost:8080/cartoArba/ProxyMap'],
		//	'http://10.16.188.66:8080/cartoArba/ProxyMap',
            {
                layers: layerdata.layer,
                transparent: true,
                format: layerdata.format,
                styles:layerdata.style
            }, {
                opacity: layerdata.opacity,
                buffer:0,
                transitionEffect: 'resize',
                isBaseLayer:layerdata.baselayer,
                singleTile: layerdata.singletile
            });
             }      	
	    layer.setVisibility(layerdata.visible);
	    layer.description = layerdata.description; //descripcion en accordion
	    layer.orderlayer = layerdata.orderlayer;
	    layer.service = layerdata.service;
	    layer.id = layerdata.id;
	    layer.url = strurl;
	   // layer.url = 'http://10.16.188.66:8080/cartoArba/ProxyMap';
	    layer.title = layerdata.title;
	    layer.showInPanel=true; // Determina si el layer es mostrado en la capa de layers
	    layer.cstyle = layerdata.style;
	    layer.cstyleTransparent = layerdata.styleTransparent;
	    layer.stylelabel = layerdata.stylelabel;
	    layer.cstylelabelTransparent = layerdata.stylelabeltransparent;
	    layer.layeride = layerdata.layeride;
	    layer.queryable = layerdata.queryable;
	    layer.cached = layerdata.cached;
	    layer.namedgrouped = layerdata.namedgrouped;
	    layer.namedgroupedtransparent = layerdata.namedgroupedtransparent;
	    layer.category = layerdata.category;
	    layer.querylayers = layerdata.querylayers;
    	layer.maxresolution = layerdata.maxresolution; 
    	layer.layerWithTable = layerdata.layerWithTable;
    	layer.urlMetadata =layerdata.metadata;
	    
	    if(layerdata.layer=="carto:tag")
	    {
	    	layer.showInPanel=false; //HORRIBLE, lo hago para no borrar la fila de la tabla...... por ahora.
	    }	
	    
	    if(layerdata.customparam!="")
	    	layer.customparam = layerdata.customparam;	    	
	    
	    map.addLayer(layer);

    	if(layerdata.baselayer)
    		ML_ArbaCapaBase = layer;
    	
    	
    	
	    // Evento que chequea session en el mapa  	
    	layer.events.register('loadend', this, function(){onloadstartCheckSession(layer);});	   
    	
//	}
}

//Setea la propiedad de visibilidad del layer id pasado por parametro
function ML_setCheckBoxProperties(layerid)
{
	ML_changeVisibility(layerid);
	                   
	$("#map").trigger('completeChangeVisibilityLayer');

}



function ML_getTypeLayer(layer)
{
	if(layer.customlayer!=undefined && layer.customlayer)
		return "CAPA DE USUARIO";
	
	if(layer.urbanas!=undefined && layer.urbanas)
		return "URBANAS";

	if(layer.ddhh!=undefined && layer.ddhh)
		return "DDHH";
		
	if(layer.reservorio!=undefined && layer.reservorio)
		return "RESERVORIO"
	
	return "CAPA"

}



// cambia la visibilidad del layerid pasado por parametro
function ML_changeVisibility(layerid){
	
	
	if(layerid == -1)
	{
		vectorQueryLayer.setVisibility(!vectorQueryLayer.getVisibility());
		return;
	}	
		
	var lay = ML_GetLayerById(layerid);	
	
	//console.log(lay);
	var check;
	
	
	if(lay.customlayer!=undefined && lay.customlayer)
		check = $("#CL_checkVisible-"+layerid);//capas de usuario
	else
		if(lay.urbanas!=undefined && lay.urbanas)
			check = $("#MU_checkVisible-"+layerid); //capa de urbanas
		else
			if(lay.ddhh!=undefined && lay.ddhh)
				check = $("#DH_checkVisible-"+layerid); //capa de derechos humanos
			else
				if(lay.fiscalizacion!=undefined && lay.fiscalizacion)
					check = $("#Fisca_checkVisible-"+layerid);  
				else
					if(lay.dpout!=undefined && lay.dpout) 
						check = $("#dpout_checkVisible-"+layerid);
					else 
						if(lay.revaluo_rural!=undefined && lay.revaluo_rural)
						    	check = $("#RR_checkVisible-"+layerid);//capa de revaluo rural
						else 
							if (lay.reservorio!=undefined && lay.reservorio)
								check = $("#Reservorio_checkVisible-"+layerid) //capa de reservorio
							else
								check = $("#L_checkVisible-"+layerid); //capas en general y capas ide
			
						
		
	//lay.setVisibility(!lay.getVisibility());
	
	/*Loguear cuando se prende una capa de usuarios*/
	
	/*if(!lay.getVisibility() && layerid.indexOf("_cl")!=-1)
	{
		var dataRequest = new Object();
		dataRequest.idlayer = parseInt(layerid.replace("_cl",""));
		dataRequest.accion = "prende capa de usuario";
		$.ajax({
			  type: "POST",
			  url: "customlayer/saveAuditoria",
			  data: JSON.stringify(dataRequest),
			  contentType: 'application/json',
			  success: function(data) {},
			  error:function(){}
		});
		
		
		
	}*/
		
		//$.post("customlayer/saveAuditoria",{idlayer: parseInt(layerid.replace("_cl",""))}, function(data, status){});
	if(check[0] != undefined)
		
		lay.setVisibility(check[0].checked);
	
	
	$("#map").trigger("changeVisibilityLayer",lay);
	
	ML_updateVisibilityLayerLabel();
}

//Cambia la opacidad del layerid pasado por parametro
function ML_changeOpacity(layerid,value)
{
	var lay = ML_GetLayerById(layerid);
	lay.setOpacity(value);
}

function ML_changeSliderOpacity(layerid,value)
{
	ML_changeOpacity(layerid,value/100);
}

/*
 * Retorna un string separado por comas, con los nombres de los layers que se encuentran visible en el mapa
 * equalBaseLayer parametro para determinar si devuelve o no los que son baselayer
 * */
function ML_getLayersVisible(equalBaseLayer)
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS")  &&(layerv.id!=ML_layerLabel.id) )
		{
			if(equalBaseLayer)
			{
				
				if(layerv.id==ML_ArbaCapaBase.id)
				{
					arrLayerVisible.push(layerv.params.LAYERS);
				}
			}else
				{
					if(layerv.id!=ML_ArbaCapaBase.id && (!layerv.layeride) && arrLayerVisible.indexOf(layerv.params.LAYERS)==-1)
					{
						arrLayerVisible.push(layerv.params.LAYERS);
					}
				}	
		}
			
	});
	return arrLayerVisible.join(",");
}

/*Retorna una lista de capas ide visibles a las cuales no se les pide info desde el servidor*/

function ML_getLayersIDEVisible()
{
	var arrLayerVisible = [];
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility &&  layerv.layeride && !layerv.queryable && arrLayerVisible.indexOf(layerv.params.LAYERS)==-1)
			arrLayerVisible.push(layerv);
			
	});
	return arrLayerVisible;
}


/*
 * Retorna un string separado por comas, con los nombres de los layers que se encuentran visibles en el mapa y son queryables
 * equalBaseLayer parametro para determinar si devuelve o no los que son baselayer
 * */
function ML_getQueryLayersVisible(equalBaseLayer)
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS")  &&(layerv.id!=ML_layerLabel.id) )
		{
			if(equalBaseLayer)
			{
				
				if(layerv.id==ML_ArbaCapaBase.id)
				{
					arrLayerVisible.push(layerv.querylayers);
				}
			}else
				{
					
					
					if(layerv.id!=ML_ArbaCapaBase.id && (!layerv.layeride) && arrLayerVisible.indexOf(layerv.params.LAYERS)==-1)
					{
						if(layerv.customlayer!=undefined && layerv.customlayer)
							arrLayerVisible.push(layerv.params.LAYERS);
						else
							arrLayerVisible.push(layerv.querylayers);
					}
				}	
		}
			
	});
	return arrLayerVisible.join(",");
}

/*
 * Retorna un string separado por comas, con los nombres de los estilos de los layers que se encuentran visible en el mapa
 * equalBaseLayer parametro para determinar si devuelve o no los que son baselayer
 * */
function ML_getStyleOfLayersVisible(equalBaseLayer)
{
	var arrStylesLayerVisible = new Array();
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS")  &&(layerv.id!=ML_layerLabel.id) )
		{
			if(equalBaseLayer)
			{
				
				if(layerv.id==ML_ArbaCapaBase.id)
				{
					arrStylesLayerVisible.push(layerv.params.STYLES);
					arrLayerVisible.push(layerv.params.LAYERS);
				}
			}else
				if(layerv.id!=ML_ArbaCapaBase.id && (!layerv.layeride) && arrLayerVisible.indexOf(layerv.params.LAYERS)==-1)
				{
					arrStylesLayerVisible.push(layerv.params.STYLES);
					arrLayerVisible.push(layerv.params.LAYERS);
				}
		}
			
	});
	return arrStylesLayerVisible.join(",");
}


/*
 * Retorna un string separado por coma con los ids de los layers IDE  que se encuentran visible en el mapa
 * */
function ML_getIdsLayersIDEVisible()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility && layerv.layeride)
					arrLayerVisible.push(layerv.id);
			
	});
	
	return arrLayerVisible.join(",");
}

/*
 * Retorna un string separado por coma con los ids de los layers de Operativo  que se encuentran visible en el mapa
 * */
function ML_getIdsOperativosFisca()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility && layerv.fiscalizacion!=undefined && layerv.fiscalizacion && layerv.service.toUpperCase() == "WFS")
					arrLayerVisible.push(layerv.id.replace("fisca_",""));
			
	});
	
	return arrLayerVisible.join(",");
}

function ML_getIdsLayersdpout()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility && layerv.dpout!=undefined && layerv.dpout && layerv.service.toUpperCase() == "WFS")
					arrLayerVisible.push(layerv.id.replace("dpout_",""));
			
	});
	
	return arrLayerVisible.join(",");
}


/*Devuelve las capas prendidas de Revaluo Rural WMS*/
function ML_getLayersRR_wms()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility && layerv.service == "WMS" && layerv.revaluo_rural!=undefined && layerv.revaluo_rural)
		{
			arrLayerVisible.push(layerv.params.LAYERS);
		}
			
	});
	
	return arrLayerVisible.join(",");
}

/*Devuelve las capas prendidas de Revaluo Rural WFS*/
function ML_getLayersRR_wfs()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if(layerv.visibility && layerv.service == "WFS" && layerv.revaluo_rural!=undefined && layerv.revaluo_rural)
			arrLayerVisible.push(layerv.id.replace("_rr",""));
			
	});
	
	return arrLayerVisible.join(",");
}

/*
 * Retorna un string separado por comas, con los ids de los layers que se encuentran visible en el mapa
 * */
function ML_getIdsLayersVisible()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS") &&(!layerv.layeride) &&(layerv.id!=ML_layerLabel.id) )
		{
			arrLayerVisible.push(layerv.id);
		}
	});
	return arrLayerVisible.join(",");
}

/*
 * Retorna un string separado por comas, con los nombres de los layers labels que se encuentran visible en el mapa
 * */
function ML_getLayersLabelsVisible()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS") && (layerv.revaluo == undefined) && (layerv.revaluo_rural == undefined) &&(layerv.stylelabel!=""))
			arrLayerVisible.push(layerv.params.LAYERS);
	});
	return arrLayerVisible.join(",");
}

/*
 * Retorna un string separado por comas, con los nombres de los styles labels que se encuentran visible en el mapa
 * */
function ML_getLayersStyleLabelsVisible()
{
	var arrLayerVisible = new Array();
	$.each(map.layers, function(index, layerv) {
		if((layerv.visibility) &&(layerv.service=="WMS") && (layerv.revaluo == undefined) && (layerv.revaluo_rural == undefined) && (layerv.stylelabel!=""))
			if(MM_IS_TRANSPARENT_MAP)
			{
				arrLayerVisible.push(layerv.cstylelabelTransparent);
			}
			else
				{
					arrLayerVisible.push(layerv.stylelabel);
				}
				
	});
	return arrLayerVisible.join(",");
}



//Retorna el layer correspondiente al id pasado por parametro
function ML_GetLayerById(idLayer)
{
	var found=null;
	$.each(map.layers, function(index, value) {
		if(value.id == idLayer)
			found=  value;
	});
	return found;

}

//Retorna el control correspondiente al id pasado por parametro
function ML_GetControlById(idControl)
{
	var found=null;
	$.each(map.controls, function(index, value) {
		if(value.id == idControl)
			found=  value;
	});
	return found;
}



function ML_getUrlForLegendGraphicWMS(layer)
{
	//Si es un layer grupo devolver todas las url del layer en un mismo string separadas por comas
		var respuesta = "";
		//es un grupo, iterar los layers y sus estilos
		var  arr_layers = layer.params['LAYERS'].split(',');
		var  arr_styles = layer.params['STYLES'].split(',');
		
		for (var w=0;w<arr_layers.length;w++)
		{
			//si el layer tiene definido un estilo empty no agregar la url a la respuesta
			if(arr_styles[w].toString()!="empty")
				respuesta = respuesta + layer.url+'?REQUEST=GetLegendGraphic&LAYER='+arr_layers[w].toString()+'&STYLE='+arr_styles[w].toString()+'&LEGEND_OPTIONS=fontName:Helvetica%20Neue;fontAntiAliasing:true;fontColor:0x444444;fontSize:12;forceLabels:on&FORMAT=image%2Fpng&WIDTH=20&HEIGHT=20&SCALE='+MM_getScale()+',';
		}
		//elimino la ultima coma al devolver la respuesta
		return respuesta.substring(0, respuesta.length-1);
}

function ML_getUrlForLegendGraphicWFS(layer)
{
	return layer.url+'?REQUEST=GetLegendGraphic&LAYER='+layer.layer+'&STYLE='+layer.styleforlegend+'&LEGEND_OPTIONS=fontName:Helvetica%20Neue;fontAntiAliasing:true;fontColor:0x444444;fontSize:12;forceLabels:on&FORMAT=image%2Fpng&WIDTH=20&HEIGHT=20&SCALE='+MM_getScale();
}

function ML_getUrlForLegendGraphicByStyleLegend(layername,styleforlegend,url)
{
	return url+'?REQUEST=GetLegendGraphic&LAYER='+layername+'&STYLE='+styleforlegend+'&LEGEND_OPTIONS=fontName:Helvetica%20Neue;fontAntiAliasing:true;fontColor:0x444444;fontSize:12;forceLabels:on&FORMAT=image%2Fpng&WIDTH=20&HEIGHT=20&SCALE='+MM_getScale();
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////          CAPAS EXTERNAS ////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var ML_EXTERNAL="EXTERNAL"; // Identifica el tipo de servicio es externo. Se utiliza en ML_addCapaBaseExternal para identificar un servicio externo

var ML_SINCAPABASE= "Sin Capa Base";
var ML_GOOGLESATELLITAL = "Google Satellite"; // Nombre de la capa externa de google satellite (photographic map)
var ML_GOOGLEROADMAP = "Google Calle"; // Nombre de la capa externa de google calle (normal, default 2D map)

var ML_GOOGLEHYBRID = "Google Hibrido"; // Nombre de la capa externa de google calle (photographic map + roads and city names)
var ML_GOOGLETERRAIN = "Google Terreno"; // Nombre de la capa externa de google calle (map with mountains, rivers, etc.)
var ML_GOOGLETRAFFIC = "Google Trafico"; // Nombre de la capa externa de google trafic

var ML_ARGENMAP = "IGN Argenmap";
var ML_MAPQUESTAERIAL = "MapQuest Aereo";
var ML_ARBASATELITAL = "ARBA Satelital";

var ML_ESRISATELLITE = "Esri Satelite";
var ML_ESRINATIONALGEOGRAPHIC = "Esri National Geographic";
var ML_ESRIPHYSICAL = "ESRI Physical";
var ML_ESRISTREETS = "ESRI Streets";
var ML_ESRITERRAIN = "ESRI Terrain";
var ML_ESRITOPO = "ESRI Topo";
var ML_ESRITRANSPORTATION = "ESRI Transportation";
var ML_STAMENTERRAIN = "STAMEN Terrain";
var ML_STAMENTONER = "STAMEN Toner";
var ML_STAMENWATERCOLOR = "STAMEN Water Color";
var ML_CARTOPOSITRON = "CARTO Positron";
var ML_CARTODARK = "CARTO Dark";
var ML_OPENSTREETMAPMAPNICK = "OSM Mapnick";
var ML_OSMCIRCLEMAP = "OSM Circle Map";
var ML_OSMBLACKANDWITHE = "OSM Black and Withe";
var ML_OSMWORLD3D = "OSM WORLD 3D";


/**
 * Retorna una nueva capa de MapQuest OpenStreetMap
 * @returns {___anonymous8029_8041}
 */


function getTileURL(bounds) {

	  var res = this.map.getResolution();
	  var x = Math.round((bounds.left - this.maxExtent.left) / (res * this.tileSize.w));
	  var y = Math.round((this.maxExtent.top - bounds.top) / (res * this.tileSize.h));
	  var z = this.map.getZoom();
	  var limit = Math.pow(2, z);
	  if (y < 0 || y >= limit) {
	    return null;
	  }
	  else {
	    x = ((x % limit) + limit) % limit;
	    url = this.url;
	    path= ":"+ z + "/" + x + "/" + y +"?format=image%2F" + this.type;
	    if (url instanceof Array) {
	      url = this.selectUrl(path, url);
	    }
	    return url+path;
	  }
}

function ML_getIgnArgenMap(){
	
	
	
	/*var layerIgnArgenMap = new OpenLayers.Layer.TMS(
			ML_ARGENMAP, 
		    "https://wms.ign.gob.ar/geoserver/gwc/service/tms/1.0.0/capabaseargenmap/EPSG:3857/EPSG:3857:", 
		    {numZoomLevels: 18, type: 'png', getURL: getTileURL, displayOutsideMaxExtent: true} 
		);*/

	/*var layerIgnArgenMap = new OpenLayers.Layer.TMS(
			ML_ARGENMAP, // name for display in LayerSwitcher
		    "https://wms.ign.gob.ar/geoserver/gwc/service/tms/1.0.0/", // service endpoint
		    {layername: "capabaseargenmap/EPSG:3857/EPSG:3857", type: "png"} // required properties
		);*/
	
	//var layerIgnArgenMap = new OpenLayers.Layer.XYZ( ML_ARGENMAP,'https://wms.ign.gob.ar/geoserver/gwc/service/tms/1.0.0/capabaseargenmap@EPSG%3A3857@png/{z}/{x}/{-y}.png',{sphericalMercator: true, visibility: false} );
	
	var layerIgnArgenMap = new OpenLayers.Layer.WMSCustom(ML_ARGENMAP,
			['https://wms.ign.gob.ar/geoserver/wms'],
      {
		    layers: "capabaseargenmap",
            transparent: true,
            format: "image/png8",
            styles:""
        }, {
            opacity: 1,
            buffer:0,
            transitionEffect: 'resize',
            isBaseLayer:false,
            singleTile: false
        });
	layerIgnArgenMap.setVisibility(true);
	layerIgnArgenMap.description = "IGN Argenmap";
	layerIgnArgenMap.url = "https://wms.ign.gob.ar/geoserver/wms";
    layerIgnArgenMap.title = ML_ARGENMAP;
	layerIgnArgenMap.showInPanel=false; // Determina si el layer es mostrado en la capa de layers
	layerIgnArgenMap.cstyle = "";
	layerIgnArgenMap.cstyleTransparent = "";
	layerIgnArgenMap.stylelabel =  "";
	layerIgnArgenMap.cstylelabelTransparent = "";
	layerIgnArgenMap.layeride = false;
	layerIgnArgenMap.queryable = false;
	layerIgnArgenMap.cached = false;
	layerIgnArgenMap.namedgrouped =  "";
	layerIgnArgenMap.namedgroupedtransparent =  "";
	layerIgnArgenMap.category =  "";
	layerIgnArgenMap.querylayers =  "";
	layerIgnArgenMap.maxresolution = 0; 
	layerIgnArgenMap.layerWithTable = false;
	
	layerIgnArgenMap.service = ML_EXTERNAL;
	return layerIgnArgenMap;
}

/**
 * Retorna una nueva capa de MapQuest Aerial
 * @returns {___anonymous8029_8041}
 */
function ML_getGoogleMapQuestAerial(){
	var layerMQAerial =	new OpenLayers.Layer.OSM(ML_MAPQUESTAERIAL, ["http://otile1.mqcdn.com/tiles/1.0.0/sat/${z}/${x}/${y}.jpg",
	                                                                            "http://otile2.mqcdn.com/tiles/1.0.0/sat/${z}/${x}/${y}.jpg",
	                                                                            "http://otile3.mqcdn.com/tiles/1.0.0/sat/${z}/${x}/${y}.jpg",
	                                                                            "http://otile4.mqcdn.com/tiles/1.0.0/sat/${z}/${x}/${y}.jpg"]);
	layerMQAerial.service = ML_EXTERNAL;
	return layerMQAerial;
}



/**
 * Retorna una nueva capa de google satellite
 * @returns {___anonymous9085_9100}
 */
function ML_getGoogleSatellite(){
	var layerGSatellital = new OpenLayers.Layer.XYZ( ML_GOOGLESATELLITAL,"https://mt1.google.com/vt?lyrs=s@189&gl=cn&x=${x}&y=${y}&z=${z}",{sphericalMercator: true, visibility: false} );
	layerGSatellital.useAPI = false;
	layerGSatellital.service = ML_EXTERNAL;
	return layerGSatellital;
}


/**
 * Retorna una nueva capa de google Calle
 * @returns {___anonymous9364_9376}
 */
function ML_getGoogleRoadMap(){
	/*var layerGRoadMap = new OpenLayers.Layer.Google(
			ML_GOOGLEROADMAP,
            {type: google.maps.MapTypeId.ROADMAP, visibility: true, numZoomLevels:21}
   
   );*/
	var layerGRoadMap = new OpenLayers.Layer.XYZ( ML_GOOGLEROADMAP,
            "https://mt1.google.com/vt/lyrs=r&x=${x}&y=${y}&z=${z}",
            {sphericalMercator: true} );
	
	
	layerGRoadMap.service = ML_EXTERNAL;
	return layerGRoadMap;
}

/**
 * Retorna una nueva capa de google terrain
 * @returns {___anonymous9637_9649}
 */
function ML_getGoogleTerrain(){
	/*var layerGTerrain = new OpenLayers.Layer.Google(
			ML_GOOGLETERRAIN,
            {type: google.maps.MapTypeId.TERRAIN, visibility: true, numZoomLevels:21}
   
   );*/
	
	var layerGTerrain = new OpenLayers.Layer.XYZ( ML_GOOGLETERRAIN,
            "https://mt1.google.com/vt/lyrs=t&x=${x}&y=${y}&z=${z}",
            {sphericalMercator: true} );
	
	layerGTerrain.service = ML_EXTERNAL;
	return layerGTerrain;
}

/**
 * Retorna una nueva capa de google hibrido
 * @returns {___anonymous9906_9917}
 */
function ML_getGoogleHybrid(){
	
	var layerGHybrid = new OpenLayers.Layer.XYZ( ML_GOOGLEHYBRID,"https://mt1.google.com/vt/lyrs=y&x=${x}&y=${y}&z=${z}",{sphericalMercator: true, visibility:false});
	layerGHybrid.useAPI = false;
	layerGHybrid.service = ML_EXTERNAL;
	return layerGHybrid;
}


/**
 * Retorna una nueva capa de ARBA Satelital
 * @returns {___anonymous9906_9917}
 */
function ML_getARBASatelital(){
	var layerARBASat = new OpenLayers.Layer.WMSCustom("ARBA Satelital",
				'./ProxyMapARBASatelital',
            {
                layers: 'ARBA Satelital',
                transparent: false,
                format: 'image/png8',
                styles:''
            }, {
                opacity: 1,
                buffer:0,
                transitionEffect: 'resize',
                isBaseLayer:true,
                singleTile: false
            });                   	
   	layerARBASat.cached = true;
	layerARBASat.service = ML_EXTERNAL;
	
	return layerARBASat;
}



/**
 * Retorna una nueva capa de google traffic
 * @returns {___anonymous9906_9917}
 */
function ML_getGoogleTraffic(){
	
	var layerGTraffic = new OpenLayers.Layer.XYZ( ML_GOOGLETRAFFIC,
            "https://mt1.google.com/vt?lyrs=h@159000000,traffic|seconds_into_week:-1&style=3&x=${x}&y=${y}&z=${z}",
            {sphericalMercator: true} );
	
	layerGTraffic.service = ML_EXTERNAL;
	return layerGTraffic;
}




/**
 * Retorna una nueva capa de esri satellite
 */
function ML_getESRISatellite(){
	
	var layerESRISatellite = new OpenLayers.Layer.XYZ( ML_ESRISATELLITE,
            "https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRISatellite.service = ML_EXTERNAL;
	return layerESRISatellite;
}


/**
 * Retorna una nueva capa de esri National Geographic
 */
function ML_getESRINationalGeographic(){
	
	var layerESRINationalGeographic = new OpenLayers.Layer.XYZ( ML_ESRINATIONALGEOGRAPHIC,
            "http://services.arcgisonline.com/ArcGIS/rest/services/NatGeo_World_Map/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRINationalGeographic.service = ML_EXTERNAL;
	return layerESRINationalGeographic;
}


/**
 * Retorna una nueva capa de esri Physical
 */
function ML_getESRIPhysical(){
	
	var layerESRIPhysical = new OpenLayers.Layer.XYZ( ML_ESRIPHYSICAL,
            "https://server.arcgisonline.com/ArcGIS/rest/services/World_Physical_Map/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRIPhysical.service = ML_EXTERNAL;
	return layerESRIPhysical;
}


/**
 * Retorna una nueva capa de esri Streets
 */
function ML_getESRIStreets(){
	
	var layerESRIStreets = new OpenLayers.Layer.XYZ( ML_ESRISTREETS,
            "https://server.arcgisonline.com/ArcGIS/rest/services/World_Street_Map/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRIStreets.service = ML_EXTERNAL;
	return layerESRIStreets;
}


/**
 * Retorna una nueva capa de esri terrain
 */
function ML_getESRITerrain(){
	
	var layerESRITerrain = new OpenLayers.Layer.XYZ( ML_ESRITERRAIN,
            "https://server.arcgisonline.com/ArcGIS/rest/services/World_Terrain_Base/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRITerrain.service = ML_EXTERNAL;
	return layerESRITerrain;
}



/**
 * Retorna una nueva capa de esri topo
 */
function ML_getESRITopo(){
	
	var layerESRITopo = new OpenLayers.Layer.XYZ( ML_ESRITOPO,
            "https://server.arcgisonline.com/ArcGIS/rest/services/World_Topo_Map/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRITopo.service = ML_EXTERNAL;
	return layerESRITopo;
}

/**
 * Retorna una nueva capa de esri transportation
 */
function ML_getESRITransportation(){
	
	var layerESRITransportation = new OpenLayers.Layer.XYZ( ML_ESRITRANSPORTATION,
            "https://server.arcgisonline.com/ArcGIS/rest/services/Reference/World_Transportation/MapServer/tile/${z}/${y}/${x}",
            {sphericalMercator: true} );
	
	layerESRITransportation.service = ML_EXTERNAL;
	return layerESRITransportation;
}





/**
 * Retorna una nueva capa de Stamen Terrain
 */
function ML_getStamenTerrain(){
	
	var layerStamenterrain = new OpenLayers.Layer.XYZ( ML_STAMENTERRAIN,
            "http://a.tile.stamen.com/terrain/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerStamenterrain.service = ML_EXTERNAL;
	return layerStamenterrain;
}

/**
 * Retorna una nueva capa de Stamen toner
 */
function ML_getStamenToner(){
	
	var layerStamenToner = new OpenLayers.Layer.XYZ( ML_STAMENTONER,
            "http://tile.stamen.com/toner/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerStamenToner.service = ML_EXTERNAL;
	return layerStamenToner;
}

/**
 * Retorna una nueva capa de Stamen watercolor
 */
function ML_getStamenWaterColor(){
	
	var layerStamenWaterColor = new OpenLayers.Layer.XYZ( ML_STAMENWATERCOLOR,
            "http://tile.stamen.com/watercolor/${z}/${x}/${y}.jpg",
            {sphericalMercator: true} );
	
	layerStamenWaterColor.service = ML_EXTERNAL;
	return layerStamenWaterColor;
}


/**
 * Retorna una nueva capa de carto positron
 */
function ML_getCartoPositron(){
	
	var layerCartoPositron = new OpenLayers.Layer.XYZ( ML_CARTOPOSITRON,
            "https://cartodb-basemaps-a.global.ssl.fastly.net/light_all/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerCartoPositron.service = ML_EXTERNAL;
	return layerCartoPositron;
}


/**
 * Retorna una nueva capa de carto dark
 */
function ML_getCartoDark(){
	
	var layerCartoDark = new OpenLayers.Layer.XYZ( ML_CARTODARK,
            "http://a.basemaps.cartocdn.com/dark_all/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerCartoDark.service = ML_EXTERNAL;
	return layerCartoDark;
}


/**
 * Retorna una nueva capa de open street map mapnick
 */
function ML_getOSMMapnick(){
	
	var layerOSMMapnick = new OpenLayers.Layer.XYZ( ML_OPENSTREETMAPMAPNICK,
            "http://tile.openstreetmap.org/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerOSMMapnick.service = ML_EXTERNAL;
	return layerOSMMapnick;
}


/**
 * Retorna una nueva capa de open street map circle map
 */
function ML_getOSMCircleMap(){
	
	var layerOSMCircleMap = new OpenLayers.Layer.XYZ( ML_OSMCIRCLEMAP,
            "http://tile.thunderforest.com/cycle/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerOSMCircleMap.service = ML_EXTERNAL;
	return layerOSMCircleMap;
}


/**
 * Retorna una nueva capa de open street map black and white
 */
function ML_getOSMBlackAndWhite(){
	
	var layerOSMBlackAndWhite = new OpenLayers.Layer.XYZ( ML_OSMBLACKANDWITHE,
            "http://tiles.wmflabs.org/bw-mapnik/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerOSMBlackAndWhite.service = ML_EXTERNAL;
	return layerOSMBlackAndWhite;
}


/**
 * Retorna una nueva capa de open steet map world 3D
 */
function ML_getOSMWorld3D(){
	
	var layerOSMWorld3D = new OpenLayers.Layer.XYZ( ML_OSMWORLD3D,
            "http://tiles.osm3world.org/osm/pngtiles/n/${z}/${x}/${y}.png",
            {sphericalMercator: true} );
	
	layerOSMWorld3D.service = ML_EXTERNAL;
	return layerOSMWorld3D;
}


//Actualiza los estilos de los layes dependiendo si el mapa se encuntra transparente o no, tambien actualiza el estilo de los labels
function ML_updateStyles()
{
	var index;
	for (index = 0; index < map.layers.length; ++index) {
	    if((map.layers[index].service=="WMS") && (map.layers[index].id!=ML_layerLabel.id) && map.layers[index].revaluo ==undefined)
	    {
	    	if(MM_IS_TRANSPARENT_MAP)
	    	{
	    		map.layers[index].params.STYLES = map.layers[index].cstyleTransparent;	
	    	}
	    	else
	    		{
	    			map.layers[index].params.STYLES = map.layers[index].cstyle;	
	    		}
			
	    }
	}		
	ML_updateVisibilityLayerLabel();
	var to_lg = setTimeout(
							function()
							{
								$("#map").trigger("completeUpdateStyles");
								clearTimeout(to_lg);
							}
							,800);
		
}


//Setea los estilos no transparentes a todos los layers WMS
/*function ML_setDefaultStyle()
{
	var index;
	for (index = 0; index < map.layers.length; ++index) {
	    if((map.layers[index].service=="WMS") && (map.layers[index].id!=ML_layerLabel.id))
	    {
			map.layers[index].params.STYLES = map.layers[index].cstyle;
	    }
	}	
}

//Setea los estilos transparentes a todos los layers WMS
function ML_setTransparentStyle()
{
	var index;
	for (index = 0; index < map.layers.length; ++index) {
		if((map.layers[index].service=="WMS") && (map.layers[index].id!=ML_layerLabel.id))
	    {
			map.layers[index].params.STYLES = map.layers[index].cstyleTransparent;
	    }
	}		
}*/


var ML_externalBaseVisible=null;
var ML_ArbaCapaBase=null;
/**
 * Pone visible una capa base externa, la cual corresponde con el nombre pasado por parametro
 * @param nameLayer
 */
function ML_showCapaBaseExternal(nameLayer, switchLayerGoogle) //devuelve true si se eligio poner visible una capa base externa o false si se eligio sin capa base
{
	if(ML_externalBaseVisible!=null) //Remueve la capa base anterior si es que tiene
	{
		map.removeLayer(map.getLayersByName(ML_externalBaseVisible)[0]);
		ML_externalBaseVisible = null;
	}
	if(nameLayer==ML_SINCAPABASE) 
	{
		MM_IS_TRANSPARENT_MAP=false;
		
		var estadoActualOriginCapaBase = ML_ArbaCapaBase.getVisibility();
		map.setBaseLayer(ML_ArbaCapaBase);
		ML_ArbaCapaBase.setVisibility(estadoActualOriginCapaBase);
		ML_updateStyles();//actualizo todos los estilos
		
		$("#map").trigger("setCapaBaseArba");
		
		return false;	// No hace nada, eligio SIN CAPA BASE
	}
	else
		{
			MM_IS_TRANSPARENT_MAP=true;
			ML_updateStyles();//actualizo todos los estilos
		}
	var newLayer = null;
	var newLayer2 = null;
	switch(nameLayer) {
	 case ML_GOOGLEROADMAP:
		 newLayer = ML_getGoogleRoadMap();
		 ML_externalBaseVisible = ML_GOOGLEROADMAP;
		 break;
	 case ML_GOOGLESATELLITAL:
	     newLayer = ML_getGoogleSatellite();
	     ML_externalBaseVisible = ML_GOOGLESATELLITAL;
	     break;
	 case ML_GOOGLETERRAIN:
		 newLayer = ML_getGoogleTerrain();
	     ML_externalBaseVisible = ML_GOOGLETERRAIN;
	     break;
	 case ML_GOOGLEHYBRID:
		 newLayer = ML_getGoogleHybrid();
	     ML_externalBaseVisible = ML_GOOGLEHYBRID;
	     break;
	 case ML_GOOGLETRAFFIC:
		 newLayer = ML_getGoogleTraffic();
	     ML_externalBaseVisible = ML_GOOGLETRAFFIC;
	     break;
	 case ML_MAPQUESTAERIAL:
		 newLayer = ML_getGoogleMapQuestAerial();
	     ML_externalBaseVisible = ML_MAPQUESTAERIAL;
	     break; 
	 case ML_ARGENMAP:
		 newLayer = ML_getIgnArgenMap();
	     ML_externalBaseVisible = ML_ARGENMAP;
	     break;
	 case ML_ESRISATELLITE:
		 newLayer = ML_getESRISatellite();
	     ML_externalBaseVisible = ML_ESRISATELLITE;
	     break;
	 case ML_ESRINATIONALGEOGRAPHIC:
	 	newLayer = ML_getESRINationalGeographic();
	 	ML_externalBaseVisible = ML_ESRINATIONALGEOGRAPHIC;
	    break;
	 case ML_ESRIPHYSICAL:
		newLayer = ML_getESRIPhysical();
		ML_externalBaseVisible = ML_ESRIPHYSICAL;
		break;
	 case ML_ESRISTREETS:
		newLayer = ML_getESRIStreets();
		ML_externalBaseVisible = ML_ESRISTREETS;
		break;	
	 case ML_ESRITERRAIN:
		newLayer = ML_getESRITerrain();
		ML_externalBaseVisible = ML_ESRITERRAIN;
		break;
	 case ML_ESRITOPO:
			newLayer = ML_getESRITopo();
			ML_externalBaseVisible = ML_ESRITOPO;
			break;
	 case ML_ESRITRANSPORTATION:
			newLayer = ML_getESRITransportation();
			ML_externalBaseVisible = ML_ESRITRANSPORTATION;
			break;
			
	 case ML_STAMENTERRAIN:
			newLayer = ML_getStamenTerrain();
			ML_externalBaseVisible = ML_STAMENTERRAIN;
			break;
	 case ML_STAMENTONER:
			newLayer = ML_getStamenToner();
			ML_externalBaseVisible = ML_STAMENTONER;
			break;
	 case ML_STAMENWATERCOLOR:
			newLayer = ML_getStamenWaterColor();
			ML_externalBaseVisible = ML_STAMENWATERCOLOR;
			break;
			
	 case ML_CARTOPOSITRON:
			newLayer = ML_getCartoPositron();
			ML_externalBaseVisible = ML_CARTOPOSITRON;
			break;
	 case ML_CARTODARK:
			newLayer = ML_getCartoDark();
			ML_externalBaseVisible = ML_CARTODARK;
			break;
	 
	 case ML_OPENSTREETMAPMAPNICK:
			newLayer = ML_getOSMMapnick();
			ML_externalBaseVisible = ML_OPENSTREETMAPMAPNICK;
			break;
	 case ML_OSMCIRCLEMAP:
			newLayer = ML_getOSMCircleMap();
			ML_externalBaseVisible = ML_OSMCIRCLEMAP;
			break;
	 case ML_OSMBLACKANDWITHE:
			newLayer = ML_getOSMBlackAndWhite();
			ML_externalBaseVisible = ML_OSMBLACKANDWITHE;
			break;
	 case ML_OSMWORLD3D:
			newLayer = ML_getOSMWorld3D();
			ML_externalBaseVisible = ML_OSMWORLD3D;
			break;		
	 case ML_ARBASATELITAL:
			newLayer = ML_getARBASatelital();
			ML_externalBaseVisible = ML_ARBASATELITAL;
			break;					
			
			
			
			
			
	} 
	
	
	if(newLayer != null)
	{
		var oldVisibility = ML_ArbaCapaBase.getVisibility();
		map.addLayer(newLayer);
		/*if(((nameLayer == ML_GOOGLESATELLITAL)||(nameLayer == ML_GOOGLEHYBRID))&&(newLayer.useAPI!=undefined && newLayer.useAPI)) 
			newLayer.mapObject.setTilt(0);*/
		map.setLayerIndex(newLayer,0);
		ML_oldCapaBase = map.baseLayer;
		map.setBaseLayer(newLayer);
		ML_ArbaCapaBase.setVisibility(oldVisibility);
		ML_ArbaCapaBase.setIsBaseLayer(false);
		map.updateSize();
		//map.setLayerIndex(ML_ArbaCapaBase,1);
		return true;
	}

	return false;
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////// FIN   CAPAS EXTERNAS    ////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////// CAPA DE LABELS /////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//variable que almacena la capa de labels
var ML_layerLabel;

function ML_createLayerLabel()
{
	var str_layerlabels = ML_getLayersLabelsVisible();
	if(str_layerlabels.length>0)
	{
		ML_layerLabel = new OpenLayers.Layer.WMSCustom("Label",
	    		getUrlLayerLabel(),
	            {
	                layers: str_layerlabels,
	                transparent: true,
	                format: 'image/png8',
	                buffer: 0,
	                styles:ML_getLayersStyleLabelsVisible()
	            }, {
	                opacity: 1,
	                isBaseLayer:false,
	                singleTile: true
	            });
		ML_layerLabel.maxresolution = 0;
		
		ML_layerLabel.cached = false;
		ML_layerLabel.showInPanel=false;
		//ML_layerLabel.setZIndex(1400);
		map.addLayer(ML_layerLabel);
	}
}

// Actualiza el layer de labels segun la visibilidad de cada capa
function ML_updateVisibilityLayerLabel()
{
	//layerLabel.layers= ML_getLayersLabelsVisible();
	if(map.getLayer(ML_layerLabel.id))
			map.removeLayer(ML_layerLabel,false);
	//layerLabel.removeMap(map);
	ML_createLayerLabel();
}

// Retorna la url de cualquier layer. Supone que todos poseen la misma url.
function getUrlLayerLabel()
{
	var strurl="ERROR";
	$.each(map.layers, function(index, layerv) {
		if(layerv.hasOwnProperty("stylelabel"))
			if(layerv.stylelabel!="")
				strurl = layerv.url;
	});
	return strurl;	
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////// FIN CAPA DE LABELS /////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
